#==============================================================================
# CIRCUIT EXAMPLE #1
#==============================================================================
""" 
The circuit:
    * LEDs attached to 9-13 pins (with their respective resistors)
    * Temperature sensor attached to 0 (with resistor)
    * Photosensitive sensor attached to pin 5
"""

from pyrduino import Arduino
import time

def ledBinary(arduino,num, pins):
    """ Puts a binary number on LEDs. 
        log2(number) must be major than number of LEDs """
    arduino.ledOff(pins)
    bn = [x for x in bin(num)[2:]]
    bn.reverse()
    if len(bn) > len(pins):
        print "Number too long for pins."
        return None
    for i in range(len(bn)):
        if bn[i] == '1':
            arduino.ledOn(pins[i])

# Connect Arduino
myArduino = Arduino('COM5')
# Set default pins as OUTPUT
myArduino.setOutputPins()
print "Temp.:", myArduino.readTemp(0)
time.sleep(2)
print "Light.:", myArduino.readLight(5)
time.sleep(2)
# Turn on 9-13 pins
myArduino.ledOn([9,10,11,12,13])
time.sleep(2)
myArduino.ledOff(myArduino.OUTPUT_PINS)
# Fading leds
for i in range(2):
    i=0
    while i<255:
        myArduino.writeAnalog(9,i)
        myArduino.writeAnalog(10,i)
        myArduino.writeAnalog(11,i)
        i+=5
    while i>=0:
        myArduino.writeAnalog(9,i)
        myArduino.writeAnalog(10,i)
        myArduino.writeAnalog(11,i)
        i-=5
    time.sleep(1)
time.sleep(2)
#myArduino.ledOff([12,13])
leds = list(range(9,14))
# Blink leds
for i in range(3):
    myArduino.ledOn(leds)
    time.sleep(1)
    myArduino.ledOff(leds)
    time.sleep(1)
# Binary count to 32 with LEDs
for i in range(32):
    ledBinary(myArduino,i,leds)
    time.sleep(1)
